##################
##################
#----------------#
#-Simple-Classes-###################################
#----------------#---------------------------------#
####################################################
# This is version 1.0.1 of Simple Classes.         #
# Special thanks to The Master and to his          #
# clan for help with testing out the mod.          #
# You can find The Master at his website.          #
# (mentalproductions.xgam3rs.com)                  #
# And thanks to Mattie for the great ES!           #
# Comments and bug reports are asked to            #
# be posted in the site below.                     #
# (forums.eventscripts.com/viewtopic.php?t=40541)  #
# This was made for EventScripts 2.1 OB.           #
####################################################
import es,popuplib,keyvalues,random

import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Simple Classes"
info.author = "MiB"
info.version = "1.0.1"
info.url = "warcraft-source.com"
info.basename = "cl"

def cl_handle(userid,choice,popupname):
    player = Player(userid)
    stats = Stats(userid)
    player.Damage(userid,player.getHealth())
    stats.SetStats(choice)
    es.tell(userid,"#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultYour class is now \x05%s#default."%choice)

es.keygroupload("classes_database","eventscripts/cl")
cl_classes = keyvalues.getKeyGroup("classes_database")
cl_menu = popuplib.easymenu("cl_menu",None,cl_handle)
cl_menu.settitle("Class Selection")
for cl_class in cl_classes: cl_menu.addoption(cl_class.getName(),"%s - %s"%(cl_class.getName(),cl_classes[cl_class.getName()]["description"]))
cl_players = {}
cl_primarys = "m3,xm1014,mac10,tmp,mp5navy,ump45,p90,galil,famas,ak47,m4a1,scout,sg550,aug,awp,g3sg1,sg552"
cl_shotguns = "m3,xm1014"
cl_smgs = "mac10,tmp,mp5navy,ump45,p90"
cl_rifles = "galil,famas,ak47,m4a1,aug"
cl_snipers = "awp,g3sg1,sg552,scout,sg550"
cl_secondarys = "glock,usp,p228,deagle,elite,fiveseven"
cl_grenades = "hegrenade,smokegrenade,flashbang"
sv = es.ServerVar("scl_version")
sv.set(info.version)
sv.makepublic()
# es.doblock("corelib/noisy_on")

class Player():
    def __init__(self,userid):
        self.userid = int(userid)
        self.exists = es.exists("userid",self.userid)
    def Give(self,item):
        es.server.queuecmd("es_xgive %s %s"%(self.userid,item))
    def Damage(self,target,damage):
        tar = Player(target)
        health = tar.getHealth()
        if damage < health:
            health -= damage
            tar.setHealth(health)
        else:
            entity = es.createentity("point_hurt")
            es.entitysetvalue(entity,"targetname","cl_damage")
            es.entitysetvalue(entity,"damage",damage)
            es.entitysetvalue(entity,"damagetype",32)
            es.entitysetvalue(entity,"damagetarget","cl_target")
            es.entitysetvalue(entity,"classname",Player(self.userid).getProp("weapon"))
            es.fire(target,"!self","addoutput","targetname cl_target")
            es.fire(self.userid,"cl_damage","hurt")
            es.fire(self.userid,"cl_damage","kill")
            es.fire(target,"!self","addoutput","targetname cl_player")
    def Strip(self):
        entity = es.createentity("player_weaponstrip")
        es.entitysetvalue(entity,"targetname","cl_strip")
        es.fire(self.userid,"cl_strip","strip")
        es.fire(self.userid,"cl_strip","kill")
        Player(self.userid).Give("weapon_knife")
    def LongJump(self,multi):
        multi = float(multi)
        es.setplayerprop(self.userid,"CBasePlayer.localdata.m_vecBaseVelocity","%s,%s,0"%((es.getplayerprop(self.userid,"CCSPlayer.baseclass.localdata.m_vecVelocity[0]") * multi),es.getplayerprop(self.userid,"CCSPlayer.baseclass.localdata.m_vecVelocity[1]") * multi))
    def DropWeapon(self,weapon):
        if not weapon.startswith("weapon_"): weapon = "weapon_" + weapon
        es.cexec(self.userid,"use %s"%weapon)
        es.cexec(self.userid,"drop")
    def RemoveWeapon(self,weapon):
        if not weapon.startswith("weapon_"): weapon = "weapon_" + weapon
        for entity in es.createentitylist(weapon):
            if es.getindexprop(entity,"CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(self.userid):
                es.entitysetvalue(entity,"targetname","cl_weaponremove")
                es.fire(self.userid,"cl_weaponremove","kill")
                es.cexec(self.userid,"lastinv")
    def setGrav(self,grav):
        es.entitysetvalue(Player(self.userid).getProp("index"),"gravity",grav)
    def setSpeed(self,speed):
        es.setplayerprop(self.userid,"CBasePlayer.localdata.m_flLaggedMovementValue",speed)
    def setHealth(self,health):
        es.setplayerprop(self.userid,"CBasePlayer.m_iHealth",health)
    def setArmor(self,armor):
        es.setplayerprop(self.userid,"CCSPlayer.m_ArmorValue",armor)
    def getGrav(self):
        return float(es.entitygetvalue(Player(self.userid).getPlayerIndex(),"gravity"))
    def getSpeed(self):
        return float(es.getplayerprop(self.userid,"CBasePlayer.localdata.m_flLaggedMovementValue"))
    def getHealth(self):
        return es.getplayerprop(self.userid,"CBasePlayer.m_iHealth")
    def getArmor(self):
        return es.getplayerprop(self.userid,"CCSPlayer.m_ArmorValue")
    def getNades(self):
        return [es.getplayerprop(self.userid,"CBasePlayer.localdata.m_iAmmo.011"),es.getplayerprop(self.userid,"CBasePlayer.localdata.m_iAmmo.012"),es.getplayerprop(self.userid,"CBasePlayer.localdata.m_iAmmo.013")]
    def getGre(self,nade):
        if nade == "hegrenade": return 0
        elif nade == "flashbang": return 1
        else: return 2
    def getDead(self):
        return bool(es.getplayerprop(self.userid,"CCSPlayer.baseclass.pl.deadflag"))
    def getProp(self,prop):
        return es.createplayerlist(self.userid)[self.userid][prop]

class Stats():
    def __init__(self,userid):
        self.userid = int(userid)
        self.player = Player(userid)
        self.exists = es.exists("userid",self.userid)
    def SetStats(self,cl_class):
        cl_players[self.userid]["class"] = cl_class
        cl_players[self.userid]["primary"] = cl_classes[cl_class]["primary"]
        cl_players[self.userid]["secondary"] = cl_classes[cl_class]["secondary"]
        cl_players[self.userid]["health"] = int(cl_classes[cl_class]["health"])
        cl_players[self.userid]["speed"] = float(cl_classes[cl_class]["speed"])
        cl_players[self.userid]["longjump"] = float(cl_classes[cl_class]["longjump"])
        cl_players[self.userid]["lowgrav"] = float(cl_classes[cl_class]["lowgrav"])
        cl_players[self.userid]["armor"] = int(cl_classes[cl_class]["armor"])
        cl_players[self.userid]["damage"] = int(cl_classes[cl_class]["damage"])
        cl_players[self.userid]["strip"] = int(cl_classes[cl_class]["strip"])
        cl_players[self.userid]["nades"] = str(cl_classes[cl_class]["nades"]).split(",")
        cl_players[self.userid]["restrict"] = str(cl_classes[cl_class]["restrict"])
        cl_restrictions = cl_players[self.userid]["restrict"]
        if "#primarys" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#primarys",cl_primarys)
        if "#secondarys" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#secondarys",cl_secondarys)
        if "#grenades" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#grenades",cl_grenades)
        if "#smgs" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#smgs",cl_smgs)
        if "#rifles" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#rifles",cl_rifles)
        if "#shotguns" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#shotguns",cl_shotguns)
        if "#snipers" in cl_restrictions: cl_restrictions = cl_restrictions.replace("#snipers",cl_snipers)
        cl_players[self.userid]["restrict"] = cl_restrictions.split(",")
    def ResetStats(self):
        cl_players[self.userid] = {}
        self.SetStats(random.choice(cl_classes.keys()))
    def SpawnPerks(self):
        if cl_players[self.userid]["strip"] != 0: self.player.Strip()
        if cl_players[self.userid]["primary"] != 0: self.player.Give(cl_players[self.userid]["primary"])
        if cl_players[self.userid]["secondary"] != 0: self.player.Give(cl_players[self.userid]["secondary"])
        if cl_players[self.userid]["health"] != 0: self.player.setHealth(cl_players[self.userid]["health"])
        if cl_players[self.userid]["speed"] != 0.0: self.player.setSpeed(cl_players[self.userid]["speed"])
        if cl_players[self.userid]["armor"] != 0: self.player.setArmor(cl_players[self.userid]["armor"])
        if cl_players[self.userid]["lowgrav"] != 0.0: self.player.setGrav(cl_players[self.userid]["lowgrav"])
        if cl_players[self.userid]["nades"] != 0:
            nadesn = self.player.getNades()
            if "weapon_hegrenade" in cl_players[self.userid]["nades"] and nadesn[0] == 0: self.player.Give("weapon_hegrenade")
            if "weapon_flashbang" in cl_players[self.userid]["nades"] and nadesn[1] == 0: self.player.Give("weapon_flashbang")
            if "weapon_smokegrenade" in cl_players[self.userid]["nades"] and nadesn[2] == 0: self.player.Give("weapon_smokegrenade")
    def AttackerPerks(self,attacker,weapon):
        if cl_players[self.userid]["damage"] > 0: self.player.damage(attacker,cl_players[self.userid]["damage"])
    def JumpPerks(self):
        if cl_players[self.userid]["lowgrav"] != 0.0: self.player.setGrav(cl_players[self.userid]["lowgrav"])
        if cl_players[self.userid]["longjump"] != 0.0: self.player.LongJump(cl_players[self.userid]["longjump"])
    def Restrict(self,weapon):
        if cl_players[self.userid]["restrict"] != 0:
            if weapon in ["c4","nvg","suit","knife"]: return
            if weapon in cl_players[self.userid]["restrict"]:
                es.centertell(self.userid,"%s is restricted"%weapon)
                self.player.RemoveWeapon(weapon)

def round_start(ev):
    es.msg("#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultThis server is running version \x05%s#default."%info.version)

def player_spawn(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if userid not in cl_players: stats.ResetStats()
    if int(ev["es_userteam"]) > 1:
        stats.SpawnPerks()
        es.tell(userid,"#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultYour class is currently \x05%s#default."%cl_players[userid]["class"])

def player_hurt(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if int(ev["health"]) > 0 or ev["weapon"] == "point_hurt" or ev["userid"] == ev["attacker"] or userid not in cl_players: return
    stats.AttackerPerks(int(ev["attacker"]))

def player_say(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if userid not in cl_players: stats.ResetStats()
    if ev["text"].lower() == "!classes" or ev["text"].lower() == "!class" or ev["text"].lower() == "!cl":
        popuplib.send("cl_menu",userid)
        es.tell(userid,"#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultYour class is currently \x05%s#default."%cl_players[userid]["class"])
    elif ev["text"].lower() == "!myclass" or ev["text"].lower() == "!mc": es.tell(userid,"#multi","#lightgreen[#greenSimple Classes#lightgreen] #defaultYour class is currently \x05%s#default."%cl_players[userid]["class"])

def player_disconnect(ev):
    userid = int(ev["userid"])
    if userid in cl_players: del cl_players[userid]

def player_jump(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if userid not in cl_players: return
    stats.JumpPerks()

def item_pickup(ev):
    userid = int(ev["userid"])
    stats = Stats(userid)
    if userid not in cl_players: return
    stats.Restrict(ev["item"])

def unload():
#    es.doblock("corelib/noisy_off")
    es.keygroupdelete("classes_database")
    popuplib.delete("cl_menu")
